<?php

namespace App\Http\Controllers\Admin;

use App\About;
use App\Http\Requests\TeamRequest;
use App\Team;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;

class TeamController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/teams';
    /** View folder */
    private $viewDirectory= 'admin.teams.';

    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('teams.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the pages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Team::latest();

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $teams= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('teams'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('teams.store');
        $head= metaFields('teams', 'add_new', getCurrentLocale()) ?? __('teams.new');
        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param TeamRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(TeamRequest $request) :RedirectResponse
    {

        $social  = trim(preg_replace('/\s\s+/', ' ', $request->social));
        $name = [];
        $job = [];

        foreach (languages() as $language) {
            $name_attr = [
                'name_'.$language->local => $request['name_'.$language->local]
            ];
            $job_attr = [
                'job_'.$language->local => $request['job_'.$language->local]
            ];

            $name = array_merge($name, $name_attr);
            $job = array_merge($job, $job_attr);
        }

        Team::create([
            'name' => $name,
            'job' => $job,
            'image' => $request->has('image') ? $request->image : null
        ]);
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Team $team
     * @return View
     */
    public function edit(Team $team) :View
    {
        $action= route('teams.update', $team->id);
        $head= metaFields('teams', 'edit', getCurrentLocale()) ?? __('teams.edit');
        return view( $this->viewDirectory.'form', compact('team', 'action', 'head') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param TeamRequest $request
     * @param Team $team
     * @return RedirectResponse|Redirector
     */
    public function update(TeamRequest $request, Team $team) :RedirectResponse
    {
        $social  = trim(preg_replace('/\s\s+/', ' ', $request->social));
        $name = [];
        $job = [];

        foreach (languages() as $language) {
            $name_attr = [
                'name_'.$language->local => $request['name_'.$language->local]
            ];
            $job_attr = [
                'job_'.$language->local => $request['job_'.$language->local]
            ];

            $name = array_merge($name, $name_attr);
            $job = array_merge($job, $job_attr);
        }

        $team->update([
            'name' => $name,
            'job' => $job,
            'social' => $social,
        ]);
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $about = About::withTrashed()->find($id);
        if ($about) {
            if ($about->deleted_at) {
                $about->forceDelete();
            } else {
                $about->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            About::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            About::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $about = About::withTrashed()->find($id);

        if ($about){
            $about->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $about = About::whereIn('id', $request->ids)->onlyTrashed();
        if ($about){
            $about->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
